SystemOrganization addCategory: #GODKernel!

Object subclass: #ConfigurationOfGOD
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'GODKernel'!

!ConfigurationOfGOD commentStamp: '<historical>' prior: 0!
Copy me to create a new configuration or edit and evaluate the following doits.

        "Create configuration class and initial baseline method"

        MetacelloToolBox 
                createBaseline: '1.0-baseline'
                for: 'MyProject'
                repository: 'http://www.example.com/MyProjectRepository'
                requiredProjects: #('Gofer')
                packages: #('MyProject-Core' 'MyProject-Tests')
                dependencies:
                        {('MyProject-Core' -> #('Gofer')).
                         ('MyProject-Tests' -> #('MyProject-Core'))}
                groups:
                        {('default' -> #('Core')).
                        ('Core' -> #('MyProject-Core')).
                        ('Tests' -> #('MyProject-Tests'))}.

	   "create initial development method from the baseline"

         MetacelloToolBox
               createDevelopment: '1.0'
               for: 'MyProject'
                importFromBaseline: '1.0-baseline'
                description: 'initial version'.
!

!ConfigurationOfGOD class methodsFor: 'development support' stamp: 'ESR 10/16/2014 14:34'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfGOD class methodsFor: 'private' stamp: 'ESR 10/16/2014 14:34'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfGOD class methodsFor: 'private' stamp: 'ESR 10/16/2014 14:34'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfGOD class methodsFor: 'private' stamp: 'ESR 10/16/2014 14:34'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfGOD class methodsFor: 'metacello tool support' stamp: 'ESR 10/16/2014 14:34'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGOD class methodsFor: 'loading' stamp: 'ESR 10/16/2014 14:34'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfGOD class methodsFor: 'loading' stamp: 'ESR 10/16/2014 14:34'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfGOD class methodsFor: 'loading' stamp: 'ESR 10/16/2014 14:34'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfGOD class methodsFor: 'accessing' stamp: 'ESR 10/16/2014 14:34'!
project

	^self new project! !

!ConfigurationOfGOD class methodsFor: 'development support' stamp: 'ESR 10/16/2014 14:34'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfGOD methodsFor: 'baselines' stamp: 'ER 11/8/2014 21:07'!
backupPackages
	"This method makes a backup of all GOD packages in another repository."

 Gofer new
	package: 'GODAcad';
	package: 'GODAcadTests';
	package: 'GODAcadExceptions';
	package: 'GODBases';
	package: 'GODBasesTests';
	package: 'GODBasesExceptions';
	package: 'GODCall';
	package: 'GODCallTests';
	package: 'GODConsumeAnalysis';
	package: 'GODEmail';
	package: 'GODEmailTests';
	package: 'GODFilter';
	package: 'GODFilterTests';
	package: 'GODGraphGenerator';
	package: 'GODGraphGeneratorExceptions';
	package: 'GODGraphGeneratorTests';
	package: 'GODKernel';
	package: 'GODKernelExceptions';
	package: 'GODKernelTests';
	package: 'GODPoliticalSentimentAnalysis';
	package: 'GODProcessors';
	package: 'GODProcessorsTests';
	package: 'GODProcessorsExceptions';	
	package: 'GODSentimentAnalysis';
	package: 'GODSocialNetIO';
	package: 'GODSocialNetIOTests';
	package: 'GODSpreadsheet';
	package: 'GODSpreadsheetExceptions';
	package: 'GODSpreadsheetTests';
	package: 'GODTestUtilities';
	package: 'GODTextIO';
	package: 'GODTextIOExceptions';
	package: 'GODTextIOTests';
	package: 'GODWeb';
	package: 'GODWebTests';
	package: 'WEBApp';
	package: 'JSON';
	package: 'GODExample';

   url: 'http://ss3.gemstone.com/ss/GOD' username: 'evandro2001' password: 'abc123';
   push.

	^'Backup completed'.! !

!ConfigurationOfGOD methodsFor: 'baselines' stamp: 'ER 11/9/2014 12:40'!
baseline01: spec
<version: '0.1-baseline'>

"Prerequisites for GODSocialNetIO"
	 (Installer ss)
	    project: 'SqueakSSL'; 
	    install: 'SqueakSSL-Core'; 
	    install: 'SqueakSSL-Tests'.

	(Installer ss project: 'WebClient')
	  install: 'WebClient-Core'.

"Prerequisites for GODWeb"
"
	Installer squeaksource
	 project: 'MetacelloRepository';
	 install: 'ConfigurationOfSeaside30'.
	 (Smalltalk at: #ConfigurationOfSeaside30) load.
"

"Prerequisites for GODBases"
"
	SMSqueakMap default loadUpdates.
"

	"Load Ma client server if not already loaded."
"
	(Smalltalk hasClassNamed: #MaClientSocket)
		ifFalse:
			[ SMSqueakMap default installPackageNamed: 'Ma client server' version: '1.5' ].
"
"
	#('WriteBarrier-cmm.35.mcz' 'SOLHashTables-cmm.16' 'Magma-Client-cmm.605' 'Magma-Squeak-Client-cmm.3') do:
		[ : each | (Installer repository: 'http://ss3.gemstone.com/ss/Magma') install: each ]
"	

"GOD Packages"

spec for: #common do: [
	spec blessing: #baseline.
	spec repository: 'http://www.smalltalkhub.com/mc/higoramario/GOD/main'.
	
	spec
		package: 'GODAcad';
		package: 'GODAcadTests';
		package: 'GODAcadExceptions';
		package: 'GODBases';
		package: 'GODBasesTests';
		package: 'GODBasesExceptions';
		package: 'GODCall';
		package: 'GODCallTests';
		package: 'GODConsumeAnalysis';
		package: 'GODEmail';
		package: 'GODEmailTests';
		package: 'GODFilter';
		package: 'GODFilterTests';
		package: 'GODGraphGenerator';
		package: 'GODGraphGeneratorExceptions';
		package: 'GODGraphGeneratorTests';
		package: 'GODKernel';
		package: 'GODKernelExceptions';
		package: 'GODKernelTests';
		package: 'GODPoliticalSentimentAnalysis';
		package: 'GODProcessors';
		package: 'GODProcessorsTests';
		package: 'GODProcessorsExceptions';
		package: 'GODSentimentAnalysis';
		package: 'GODSocialNetIO';
		package: 'GODSocialNetIOTests';
		package: 'GODSpreadsheet';
		package: 'GODSpreadsheetExceptions';
		package: 'GODSpreadsheetTests';
		package: 'GODTestUtilities';
		package: 'GODTextIO';
		package: 'GODTextIOExceptions';
		package: 'GODTextIOTests';
		package: 'GODWeb';
		package: 'GODWebTests';
		package: 'WEBApp';
		package: 'JSON';
		package: 'GODExample'
		].
! !

!ConfigurationOfGOD methodsFor: 'accessing' stamp: 'ESR 10/16/2014 14:34'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfGOD methodsFor: 'accessing' stamp: 'ESR 10/16/2014 14:34'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

Object subclass: #GODData
	instanceVariableNames: 'timestamp origin author title content tags width height layoutGrid id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODKernel'!

!GODData commentStamp: 'has 10/3/2014 20:26' prior: 0!
I represent the handled data inside the GOD application.

My instance variables are: 
	author:	   	  A string, the author of the information.
	content:	  A string that contains the main information.
	height:		  An integer. My height in a web page. 
	layoutGrid:	  A matrix containing GODDatas. The grid position of the GODDatas 				 	 			        represents their place in a web page.
	origin:		  A string telling where I came from.
	tags:		  An ordered collection of strings. Keywords that describe me.
	timestamp:	  A date. My birth date. 
	title:		  A string to store my title.
	width:		  An integer. My width in a web page.
!

!GODData methodsFor: 'testing' stamp: 'has 10/3/2014 21:31'!
= anotherGODData

	"I compare if two GODDatas have the same content"

	self author = anotherGODData author
		ifFalse: [^false].
	self content = anotherGODData content
		ifFalse: [^false].
	self height = anotherGODData height
		ifFalse: [^false].
	self origin = anotherGODData origin
		ifFalse: [^false].
	self tags = anotherGODData tags
		ifFalse: [^false].
	self timestamp = anotherGODData timestamp
		ifFalse: [^false].
	self title = anotherGODData title
		ifFalse: [^false].
	self layoutGrid = anotherGODData layoutGrid
		ifFalse: [^false].	
	^true.! !

!GODData methodsFor: 'accessing' stamp: 'has 10/18/2014 13:58'!
addOnLayoutGrid: aGODData at: aRow at: aColumn

	"I add a GODData at the row x column"

	(aGODData isKindOf: GODData)
		ifTrue: [layoutGrid at: aRow at: aColumn put: aGODData]
		ifFalse: [GODDataLayoutGridMustBeAGODData signal].! !

!GODData methodsFor: 'adding' stamp: 'has 9/20/2014 20:04'!
addTag: newTag
	"I add a new tag and returns the collection."
	(self tagExists: newTag)
	ifFalse:[tags add: newTag]
	ifTrue:[(GODDataTagAlreadyExistsError tagName: newTag) signal]! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:52'!
author
	^ author! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:52'!
author: aString
	author := aString! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:53'!
content
	^ content! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:53'!
content: aString
	content := aString! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 22:13'!
height
	^ height! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 22:13'!
height: anInteger
	height := anInteger! !

!GODData methodsFor: 'accessing' stamp: 'has 11/1/2014 18:30'!
id
	^ id! !

!GODData methodsFor: 'accessing' stamp: 'has 11/1/2014 18:31'!
id: anId
	id := anId! !

!GODData methodsFor: 'initialize' stamp: 'has 11/2/2014 12:09'!
initialize
	self tags: OrderedCollection new.
	self width: 0.
	self height: 0.! !

!GODData methodsFor: 'testing' stamp: 'has 9/17/2014 21:10'!
isGODData
	"True for all subclasses of GODData"

	^ true! !

!GODData methodsFor: 'testing' stamp: 'has 9/17/2014 22:32'!
isWho
	"Returns the subclass of GODData"

	^ self! !

!GODData methodsFor: 'accessing' stamp: 'has 9/26/2014 22:15'!
layoutGrid
	^ layoutGrid! !

!GODData methodsFor: 'accessing' stamp: 'has 9/26/2014 22:39'!
layoutGridRowSize: rowNumber columnSize: columnNumber

	"I create a new layoutGrid"
	layoutGrid := Matrix rows: rowNumber columns: columnNumber.! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:47'!
origin
	^ origin! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:48'!
origin: aString
	origin := aString! !

!GODData methodsFor: 'testing' stamp: 'has 9/18/2014 09:48'!
tagExists: aTagName
	" verify if a tag exists in the tag collection"
	tags do:[:each | (each = aTagName)
						ifTrue:[^true]].
	^false.! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:54'!
tags
	^ tags! !

!GODData methodsFor: 'accessing' stamp: 'has 9/20/2014 19:40'!
tags: anOrderedCollectionTag
	
	(anOrderedCollectionTag isMemberOf: OrderedCollection)
		ifTrue: [tags := anOrderedCollectionTag]
		ifFalse: [GODDataTagMustBeAnOrderedCollection signal]
	! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:38'!
timestamp
	^ timestamp! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:43'!
timestamp: aDate
	timestamp := aDate! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:53'!
title
	^ title! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 21:52'!
title: aString
	title := aString! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 22:11'!
width
	^ width! !

!GODData methodsFor: 'accessing' stamp: 'has 9/17/2014 22:12'!
width: anInteger
	width := anInteger! !
